#python imports
from typing import Optional, List

#dependency imports
from use_cases import ICartRepository

class CartDatabase(ICartRepository):
    def __init__(self):
        # Mock database setup
        self.mock_db = {
            1: [
                {"product_id": 101, "name": "Apple", "quantity": 2, "price": 0.5},
                {"product_id": 102, "name": "Milk", "quantity": 1, "price": 1.5},
            ],
            2: [
                {"product_id": 201, "name": "Bread", "quantity": 1, "price": 2.0},
            ],
        }

    def get_cart_by_user_id(self, user_id: int) -> Optional[List[dict]]:
        return self.mock_db.get(user_id)
